/*
 * manhattan - dspcomm.h
 *
 * Communication with DSP
 *
 * Copyright (C) 2012  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifndef DSPCOMM_H_INCLUDED
#define DSPCOMM_H_INCLUDED

struct dsp_stat {
	unsigned int first;
	unsigned int current;
	unsigned int igroup;
	unsigned int generation;
	unsigned int sample_size;
	unsigned int samples_per_group;
};

int dsp_stat(struct dsp_stat *stat);

unsigned int dsp_sample_size(void);
void __copy_from_dsp(unsigned int seq, unsigned long offset, void *dst,
		unsigned long count);
int copy_from_dsp(unsigned int seq, unsigned long offset, void *dst,
		unsigned long count);

int dspcomm_init(const char *device, unsigned long long offset);

#endif
