/*
 * manhattan - pu-stat.c
 *
 * Copyright (C) 2012  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <pu-lib.h>
#include <pu-buff.h>
#include <pu-proto.h>
#include <pu-proto-lib.h>
#include <dspcomm.h>

int pu_proto_stat(void *priv, struct pu_buff *skb)
{
	struct pu_buff *n;
	struct pu_stat_resp *resp;
	struct dsp_stat stat;
	int ret;

	n = pu_proto_alloc_skb(sizeof(*resp));

	resp = (void *)pu_skb_put(n, sizeof(*resp));

	ret = dsp_stat(&stat);
	if (ret) {
		pu_free_skb(n);
		return pu_proto_error_errno(priv, skb, -ret);
	}
	resp->first = cpu_to_be32(stat.first);
	resp->current = cpu_to_be32(stat.current);
	resp->igroup = cpu_to_be32(stat.igroup);
	resp->generation = cpu_to_be32(stat.generation);
	resp->sample_size = cpu_to_be32(stat.sample_size);
	resp->samples_per_group = cpu_to_be32(stat.samples_per_group);
	return pu_proto_xmit_resp(priv, n, skb);
}
